"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _isNumber2 = _interopRequireDefault(require("lodash/isNumber"));

var _isString2 = _interopRequireDefault(require("lodash/isString"));

var _kebabCase2 = _interopRequireDefault(require("lodash/kebabCase"));

var _trim2 = _interopRequireDefault(require("lodash/trim"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _isArray2 = _interopRequireDefault(require("lodash/isArray"));

var _isUndefined2 = _interopRequireDefault(require("lodash/isUndefined"));

var React = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _domLib = require("dom-lib");

var _reactDom = require("react-dom");

var _OverlayTrigger = _interopRequireDefault(require("rsuite-utils/lib/Overlay/OverlayTrigger"));

var _reactLifecyclesCompat = require("react-lifecycles-compat");

var _utils = require("rsuite-utils/lib/utils");

var _CheckTreeNode = _interopRequireDefault(require("./CheckTreeNode"));

var _constants = require("../utils/constants");

var _utils2 = require("../utils");

var _picker = require("../_picker");

var CheckTree =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2.default)(CheckTree, _React$Component);

  function CheckTree(_props) {
    var _this;

    _this = _React$Component.call(this, _props) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "getValue", function (props) {
      if (props === void 0) {
        props = _this.props;
      }

      var _props2 = props,
          value = _props2.value,
          defaultValue = _props2.defaultValue,
          _props2$uncheckableIt = _props2.uncheckableItemValues,
          uncheckableItemValues = _props2$uncheckableIt === void 0 ? [] : _props2$uncheckableIt;

      if (value && value.length) {
        return value.filter(function (v) {
          return !uncheckableItemValues.includes(v);
        });
      }

      if (defaultValue && defaultValue.length > 0) {
        return defaultValue.filter(function (v) {
          return !uncheckableItemValues.includes(v);
        });
      }

      return [];
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "getElementByDataKey", function (dataKey) {
      var ele = (0, _reactDom.findDOMNode)(_this.nodeRefs[dataKey]);

      if (ele instanceof Element) {
        return ele.querySelector("." + _this.addPrefix('checktree-view-checknode-label'));
      }

      return null;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "getFocusableMenuItems", function () {
      var filterData = _this.state.filterData;
      var childrenKey = _this.props.childrenKey;
      var items = [];

      var loop = function loop(treeNodes) {
        treeNodes.forEach(function (node) {
          if (!_this.getDisabledState(node) && !_this.getUncheckableState(node) && node.visible) {
            items.push(node);

            var _nodeData = (0, _extends2.default)({}, node, _this.nodes[node.refKey]);

            if (!_this.getExpandState(_nodeData)) {
              return;
            }

            if (node[childrenKey]) {
              loop(node[childrenKey]);
            }
          }
        });
      };

      loop(filterData);
      return items;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "isSomeNodeHasChildren", function (data) {
      return data.some(function (node) {
        return node.children;
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "shouldDisplay", function (label, searchKeyword) {
      if (!(0, _trim2.default)(searchKeyword)) {
        return true;
      }

      var keyword = searchKeyword.toLocaleLowerCase();

      if (typeof label === 'string') {
        return label.toLocaleLowerCase().indexOf(keyword) >= 0;
      } else if (React.isValidElement(label)) {
        var nodes = (0, _utils.reactToString)(label);
        return nodes.join('').toLocaleLowerCase().indexOf(keyword) >= 0;
      }

      return false;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "isControlled", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "nodes", {});
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "activeNode", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "treeView", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "bindTreeViewRef", function (ref) {
      _this.treeView = ref;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "trigger", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "bindTriggerRef", function (ref) {
      _this.trigger = ref;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "container", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "bindContainerRef", function (ref) {
      _this.container = ref;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "nodeRefs", {});
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "bindNodeRefs", function (refKey, ref) {
      _this.nodeRefs[refKey] = ref;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "menu", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "bindMenuRef", function (ref) {
      _this.menu = ref;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "position", null);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "bindPositionRef", function (ref) {
      _this.position = ref;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "getPositionInstance", function () {
      return _this.position;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "selectActiveItem", function () {
      var _this$getActiveItem = _this.getActiveItem(),
          nodeData = _this$getActiveItem.nodeData,
          layer = _this$getActiveItem.layer;

      _this.handleSelect(nodeData, +layer);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "focusNextItem", function () {
      var _this$getItemsAndActi = _this.getItemsAndActiveIndex(),
          items = _this$getItemsAndActi.items,
          activeIndex = _this$getItemsAndActi.activeIndex;

      if (items.length === 0) {
        return;
      }

      var nextIndex = activeIndex === items.length - 1 ? 0 : activeIndex + 1;

      var node = _this.getElementByDataKey(items[nextIndex].refKey);

      if (node !== null) {
        node.focus();
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "focusPreviousItem", function () {
      var _this$getItemsAndActi2 = _this.getItemsAndActiveIndex(),
          items = _this$getItemsAndActi2.items,
          activeIndex = _this$getItemsAndActi2.activeIndex;

      if (items.length === 0) {
        return;
      }

      var prevIndex = activeIndex === 0 ? items.length - 1 : activeIndex - 1;
      prevIndex = prevIndex >= 0 ? prevIndex : 0;

      var node = _this.getElementByDataKey(items[prevIndex].refKey);

      if (node !== null) {
        node.focus();
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "everyChildChecked", function (nodes, node) {
      var list = [];
      Object.keys(nodes).forEach(function (refKey) {
        var curNode = nodes[refKey];

        if (curNode.parentNode && curNode.parentNode.refKey === node.refKey && !curNode.uncheckable) {
          list.push(curNode);
        }
      });
      return list.every(function (l) {
        return l.check;
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "addPrefix", function (name) {
      return (0, _utils2.prefix)(_this.props.classPrefix)(name);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleSelect", function (activeNode, layer) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          onSelect = _this$props.onSelect;

      var selectedValues = _this.toggleChecked(activeNode, activeNode.check);

      if (_this.isControlled) {
        _this.activeNode = activeNode;
      } else {
        _this.unserializeLists({
          check: selectedValues
        });

        _this.setState({
          activeNode: activeNode,
          selectedValues: selectedValues,
          hasValue: !!selectedValues.length
        });
      }

      onChange && onChange(selectedValues);
      onSelect && onSelect(activeNode, layer, selectedValues);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleToggle", function (nodeData, layer) {
      var _this$props2 = _this.props,
          _this$props2$classPre = _this$props2.classPrefix,
          classPrefix = _this$props2$classPre === void 0 ? '' : _this$props2$classPre,
          valueKey = _this$props2.valueKey,
          onExpand = _this$props2.onExpand;
      var openClass = classPrefix + "-checktree-view-open";
      (0, _domLib.toggleClass)((0, _reactDom.findDOMNode)(_this.nodeRefs[nodeData.refKey]), openClass);
      nodeData.expand = (0, _domLib.hasClass)((0, _reactDom.findDOMNode)(_this.nodeRefs[nodeData.refKey]), openClass);

      _this.toggleExpand(nodeData, nodeData.expand);

      onExpand && onExpand(nodeData, layer, (0, _picker.createConcatChildrenFunction)(nodeData, nodeData[valueKey]));
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleKeyDown", function (event) {
      (0, _picker.onMenuKeyDown)(event, {
        down: _this.focusNextItem,
        up: _this.focusPreviousItem,
        enter: _this.selectActiveItem
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleToggleKeyDown", function (event) {
      var classPrefix = _this.props.classPrefix;

      if (!_this.treeView) {
        return;
      }

      if (event.target instanceof HTMLElement) {
        var className = event.target.className;

        if (className.includes(classPrefix + "-toggle") || className.includes(classPrefix + "-toggle-custom") || className.includes(classPrefix + "-search-bar-input")) {
          (0, _picker.onMenuKeyDown)(event, {
            down: _this.focusNextItem
          });
        }
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleSearch", function (value, event) {
      var filterData = _this.state.filterData;
      var _this$props3 = _this.props,
          onSearch = _this$props3.onSearch,
          searchKeyword = _this$props3.searchKeyword;

      if ((0, _isUndefined2.default)(searchKeyword)) {
        _this.setState({
          filterData: _this.getFilterData(value, filterData),
          searchKeyword: value
        });
      }

      onSearch && onSearch(value, event);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleClean", function () {
      var onChange = _this.props.onChange;

      _this.setState({
        selectedValues: [],
        hasValue: false,
        activeNode: {}
      });

      _this.unserializeLists({
        check: []
      });

      onChange && onChange([]);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleOnOpen", function () {
      var activeNode = _this.state.activeNode;
      var onOpen = _this.props.onOpen;

      if (activeNode) {
        var node = _this.getElementByDataKey(activeNode.refKey);

        if (node !== null) {
          node.focus();
        }
      }

      onOpen && onOpen();

      _this.setState({
        active: true
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleOnClose", function () {
      var filterData = _this.state.filterData;
      var _this$props4 = _this.props,
          onClose = _this$props4.onClose,
          searchKeyword = _this$props4.searchKeyword;

      if ((0, _isUndefined2.default)(searchKeyword)) {
        _this.setState({
          filterData: _this.getFilterData('', filterData),
          searchKeyword: ''
        });
      }

      onClose && onClose();

      _this.setState({
        active: false
      });
    });
    var _value = _props.value,
        _data = _props.data;
    _this.nodes = {};
    _this.isControlled = !(0, _isUndefined2.default)(_value);

    var _keyword = _this.getSearchKeyword(_props);

    var nextValue = _this.getValue(_props);

    var nextData = _data.concat();

    _this.flattenNodes(nextData, _props);

    _this.unserializeLists({
      check: nextValue
    }, _props);

    _this.state = {
      data: _props.data,
      value: _props.value,
      cascade: _props.cascade,
      hasValue: _this.hasValue(nextValue, _props),
      expandAll: _this.getExpandAll(_props),
      filterData: _this.getFilterData(_keyword, nextData, _props),
      searchKeyword: _keyword,
      selectedValues: nextValue,
      formattedNodes: [],
      uncheckableItemValues: _props.uncheckableItemValues,
      isSomeNodeHasChildren: _this.isSomeNodeHasChildren(_props.data)
    };
    return _this;
  }

  CheckTree.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, prevState) {
    var value = nextProps.value,
        data = nextProps.data,
        cascade = nextProps.cascade,
        expandAll = nextProps.expandAll,
        searchKeyword = nextProps.searchKeyword,
        uncheckableItemValues = nextProps.uncheckableItemValues;
    var nextState = {};

    if ((0, _isArray2.default)(data) && (0, _isArray2.default)(prevState.data) && prevState.data !== data) {
      nextState.data = data;
    }

    if ((0, _isArray2.default)(value) && (0, _isArray2.default)(prevState.value) && !(0, _utils.shallowEqualArray)(value, prevState.value)) {
      nextState.value = value;
    }

    if ((0, _isArray2.default)(uncheckableItemValues) && (0, _isArray2.default)(prevState.uncheckableItemValues) && !(0, _utils.shallowEqualArray)(uncheckableItemValues, prevState.uncheckableItemValues)) {
      nextState.uncheckableItemValues = uncheckableItemValues;
    }

    if (cascade !== prevState.cascade) {
      nextState.cascade = cascade;
    }

    if (expandAll !== prevState.expandAll) {
      nextState.expandAll = expandAll;
    }

    return Object.keys(nextState).length ? nextState : null;
  };

  var _proto = CheckTree.prototype;

  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    var _this$state = this.state,
        filterData = _this$state.filterData,
        searchKeyword = _this$state.searchKeyword,
        selectedValues = _this$state.selectedValues;
    var _this$props5 = this.props,
        value = _this$props5.value,
        _this$props5$data = _this$props5.data,
        data = _this$props5$data === void 0 ? [] : _this$props5$data,
        cascade = _this$props5.cascade,
        expandAll = _this$props5.expandAll,
        uncheckableItemValues = _this$props5.uncheckableItemValues;

    if (prevState.data !== data) {
      var nextData = data.concat();
      this.flattenNodes(nextData);
      this.unserializeLists({
        check: this.getValue()
      });
      this.setState({
        data: nextData,
        filterData: this.getFilterData(searchKeyword, nextData),
        isSomeNodeHasChildren: this.isSomeNodeHasChildren(nextData),
        hasValue: this.hasValue()
      });
    }

    if ((0, _isArray2.default)(value) && !(0, _utils.shallowEqualArray)(prevState.value, value)) {
      var nextState = {
        selectedValues: value,
        hasValue: this.hasValue(value),
        activeNode: this.activeNode
      };

      if (value && !value.length) {
        nextState.activeNode = null;
      }

      this.unserializeLists({
        check: value
      });
      this.setState(nextState);
    }

    if ((0, _isArray2.default)(uncheckableItemValues) && !(0, _utils.shallowEqualArray)(prevState.uncheckableItemValues, uncheckableItemValues)) {
      this.flattenNodes(filterData);
      this.unserializeLists({
        check: selectedValues
      });
      this.setState({
        hasValue: this.hasValue()
      });
    } // cascade 改变时，重新初始化


    if (cascade !== prevState.cascade && cascade) {
      this.flattenNodes(filterData);
      this.unserializeLists({
        check: selectedValues
      }, this.props);
      this.setState({
        cascade: cascade
      });
    }

    if (prevProps.searchKeyword !== this.props.searchKeyword) {
      this.setState({
        filterData: this.getFilterData(this.props.searchKeyword, filterData)
      });
    }
  };

  _proto.getExpandAll = function getExpandAll(props) {
    if (props === void 0) {
      props = this.props;
    }

    return props.expandAll !== undefined ? props.expandAll : props.defaultExpandAll;
  };

  _proto.getSearchKeyword = function getSearchKeyword(props) {
    if (props === void 0) {
      props = this.props;
    }

    var _props3 = props,
        searchKeyword = _props3.searchKeyword;
    return !(0, _isUndefined2.default)(searchKeyword) ? searchKeyword : '';
  };

  _proto.getNodeCheckState = function getNodeCheckState(node, cascade) {
    var childrenKey = this.props.childrenKey;

    if (!node[childrenKey] || !node[childrenKey].length || !cascade) {
      this.nodes[node.refKey].checkAll = false;
      return node.check ? _constants.CHECK_STATE.CHECK : _constants.CHECK_STATE.UNCHECK;
    }

    if (this.isEveryChildChecked(node)) {
      this.nodes[node.refKey].checkAll = true;
      return _constants.CHECK_STATE.CHECK;
    }

    if (this.isSomeChildChecked(node)) {
      this.nodes[node.refKey].checkAll = false;
      return _constants.CHECK_STATE.INDETERMINATE;
    }

    return _constants.CHECK_STATE.UNCHECK;
  };

  _proto.getExpandState = function getExpandState(node, props) {
    if (props === void 0) {
      props = this.props;
    }

    var expandAll = this.getExpandAll(props);
    var _props4 = props,
        childrenKey = _props4.childrenKey;

    if (node[childrenKey] && node[childrenKey].length) {
      if ('expand' in node) {
        return !!node.expand;
      } else if (expandAll) {
        return true;
      }

      return false;
    }

    return false;
  };

  _proto.getFilterData = function getFilterData(searchKeyword, data, props) {
    var _this2 = this;

    if (searchKeyword === void 0) {
      searchKeyword = '';
    }

    if (props === void 0) {
      props = this.props;
    }

    var _props5 = props,
        labelKey = _props5.labelKey;

    var setVisible = function setVisible(nodes) {
      if (nodes === void 0) {
        nodes = [];
      }

      return nodes.forEach(function (item) {
        item.visible = _this2.shouldDisplay(item[labelKey], searchKeyword);

        if ((0, _isArray2.default)(item.children)) {
          setVisible(item.children);
          item.children.forEach(function (child) {
            if (child.visible) {
              item.visible = child.visible;
            }
          });
        }
      });
    };

    setVisible(data);
    return data;
  };

  _proto.getActiveElementOption = function getActiveElementOption(options, refKey) {
    for (var i = 0; i < options.length; i += 1) {
      if (options[i].refKey === refKey) {
        return options[i];
      } else if (options[i].children && options[i].children.length) {
        var active = this.getActiveElementOption(options[i].children, refKey);

        if (!(0, _isEmpty2.default)(active)) {
          return active;
        }
      }
    }

    return {};
  };

  _proto.getFormattedNodes = function getFormattedNodes(nodes) {
    var _this3 = this;

    return nodes.map(function (node) {
      var formatted = (0, _extends2.default)({}, node);
      var curNode = _this3.nodes[node.refKey];

      if (curNode) {
        formatted.check = curNode.check;
        formatted.expand = curNode.expand;
        formatted.uncheckable = curNode.uncheckable;
        formatted.parentNode = curNode.parentNode;

        if (Array.isArray(node.children) && node.children.length > 0) {
          formatted.children = _this3.getFormattedNodes(formatted.children);
        }
      }

      return formatted;
    });
  };
  /**
   * 获取每个节点的disable状态
   * @param {*} node
   */


  _proto.getDisabledState = function getDisabledState(node) {
    var _this4 = this;

    var _this$props6 = this.props,
        _this$props6$disabled = _this$props6.disabledItemValues,
        disabledItemValues = _this$props6$disabled === void 0 ? [] : _this$props6$disabled,
        valueKey = _this$props6.valueKey;
    return disabledItemValues.some(function (value) {
      return (0, _utils.shallowEqual)(_this4.nodes[node.refKey][valueKey], value);
    });
  };
  /**
   * 获取节点的是否需要隐藏checkbox
   * @param {*} node
   */


  _proto.getUncheckableState = function getUncheckableState(node) {
    var _this$props7 = this.props,
        _this$props7$unchecka = _this$props7.uncheckableItemValues,
        uncheckableItemValues = _this$props7$unchecka === void 0 ? [] : _this$props7$unchecka,
        valueKey = _this$props7.valueKey;
    return uncheckableItemValues.some(function (value) {
      return (0, _utils.shallowEqual)(node[valueKey], value);
    });
  };

  _proto.getItemsAndActiveIndex = function getItemsAndActiveIndex() {
    var items = this.getFocusableMenuItems();
    var activeIndex = -1;
    items.forEach(function (item, index) {
      if (document.activeElement !== null) {
        if (item.refKey === document.activeElement.getAttribute('data-key')) {
          activeIndex = index;
        }
      }
    });
    return {
      items: items,
      activeIndex: activeIndex
    };
  };

  _proto.getActiveItem = function getActiveItem() {
    var filterData = this.state.filterData;
    var activeItem = document.activeElement;

    if (activeItem !== null) {
      var _activeItem$dataset = activeItem.dataset,
          key = _activeItem$dataset.key,
          _layer = _activeItem$dataset.layer;

      var _nodeData2 = this.getActiveElementOption(filterData, key);

      _nodeData2.check = !this.nodes[_nodeData2.refKey].check;
      _nodeData2.parentNode = this.nodes[_nodeData2.refKey].parentNode;
      return {
        nodeData: _nodeData2,
        layer: _layer
      };
    }

    return {};
  };
  /**
   * 获取已选择的items，用于显示在placeholder
   */


  _proto.getSelectedItems = function getSelectedItems(selectedValues) {
    var _this5 = this;

    var valueKey = this.props.valueKey;
    var checkItems = [];
    Object.keys(this.nodes).map(function (refKey) {
      var node = _this5.nodes[refKey];

      if (selectedValues.some(function (value) {
        return (0, _utils.shallowEqual)(node[valueKey], value);
      })) {
        checkItems.push(node);
      }
    });
    return checkItems;
  };
  /**
   * 获取每个节点的最顶层父节点的check值
   * @param {*} nodes
   * @param {*} node
   */


  _proto.getTopParentNodeCheckState = function getTopParentNodeCheckState(nodes, node) {
    if (node.parentNode) {
      return this.getTopParentNodeCheckState(nodes, node.parentNode);
    }

    return nodes[node.refKey].check;
  };
  /**
   * 获取第一层节点是否全部都为 uncheckable
   */


  _proto.getEveryFisrtLevelNodeUncheckable = function getEveryFisrtLevelNodeUncheckable() {
    var _this6 = this;

    var list = [];
    Object.keys(this.nodes).forEach(function (refKey) {
      var curNode = _this6.nodes[refKey];

      if (!curNode.parentNode) {
        list.push(curNode);
      }
    });
    return list.every(function (node) {
      return node.uncheckable;
    });
  };

  _proto.getEveryChildUncheckable = function getEveryChildUncheckable(node) {
    var _this7 = this;

    var list = [];
    Object.keys(this.nodes).forEach(function (refKey) {
      var curNode = _this7.nodes[refKey];

      if (curNode.parentNode && curNode.parentNode.refKey === node.refKey) {
        list.push(curNode);
      }
    });
    return list.every(function (node) {
      return node.uncheckable;
    });
  };
  /**
   * 判断传入的 value 是否存在于data 中
   * @param {*} values
   */


  _proto.hasValue = function hasValue(values, props) {
    var _this8 = this;

    if (values === void 0) {
      values = this.state.selectedValues;
    }

    if (props === void 0) {
      props = this.props;
    }

    var _props6 = props,
        valueKey = _props6.valueKey;
    var selectedValues = Object.keys(this.nodes).map(function (refKey) {
      return _this8.nodes[refKey][valueKey];
    }).filter(function (item) {
      return values.some(function (v) {
        return (0, _utils.shallowEqual)(v, item);
      });
    });
    return !!selectedValues.length;
  };
  /**
   * 判断第一层节点是否存在有children的节点
   * @param {*} data
   */


  _proto.isEveryChildChecked = function isEveryChildChecked(node) {
    var _this9 = this;

    var childrenKey = this.props.childrenKey;
    var children = null;

    if (node[childrenKey]) {
      children = node[childrenKey].filter(function (child) {
        return !child.uncheckable;
      });

      if (!children.length) {
        return node.check;
      }

      return children.every(function (child) {
        if (child[childrenKey] && child[childrenKey].length) {
          return _this9.isEveryChildChecked(child);
        }

        return child.check;
      });
    }

    return node.check;
  };

  _proto.isSomeChildChecked = function isSomeChildChecked(node) {
    var _this10 = this;

    var childrenKey = this.props.childrenKey;

    if (!node[childrenKey]) {
      return false;
    }

    return node[childrenKey].some(function (child) {
      if (child.check) {
        return true;
      }

      return _this10.isSomeChildChecked(child);
    });
  };
  /**
   * 拍平数组，将tree 转换为一维对象
   * @param {*} nodes tree data
   * @param {*} ref 当前层级
   */


  _proto.flattenNodes = function flattenNodes(nodes, props, ref, parentNode) {
    var _this11 = this;

    if (props === void 0) {
      props = this.props;
    }

    if (ref === void 0) {
      ref = '0';
    }

    var _props7 = props,
        labelKey = _props7.labelKey,
        valueKey = _props7.valueKey,
        childrenKey = _props7.childrenKey;

    if (!Array.isArray(nodes) || nodes.length === 0) {
      return;
    }

    nodes.forEach(function (node, index) {
      var _this11$nodes$refKey;

      var refKey = ref + "-" + index;
      node.refKey = refKey;
      _this11.nodes[refKey] = (_this11$nodes$refKey = {}, _this11$nodes$refKey[labelKey] = node[labelKey], _this11$nodes$refKey[valueKey] = node[valueKey], _this11$nodes$refKey.expand = _this11.getExpandState(node, props), _this11$nodes$refKey.uncheckable = _this11.getUncheckableState(node), _this11$nodes$refKey.refKey = refKey, _this11$nodes$refKey);

      if (parentNode) {
        _this11.nodes[refKey].parentNode = parentNode;
      }

      _this11.flattenNodes(node[childrenKey], props, refKey, _this11.nodes[refKey]);
    });
  };
  /**
   * 过滤选中的values中不包含 uncheckableItemValues 的那些值
   * @param {*} values
   */


  _proto.filterSelectedValues = function filterSelectedValues(values) {
    var _this$props$uncheckab = this.props.uncheckableItemValues,
        uncheckableItemValues = _this$props$uncheckab === void 0 ? [] : _this$props$uncheckab;
    return values.filter(function (value) {
      return !uncheckableItemValues.includes(value);
    });
  };

  _proto.serializeList = function serializeList(key, nodes) {
    if (nodes === void 0) {
      nodes = this.nodes;
    }

    var valueKey = this.props.valueKey;
    var list = [];
    Object.keys(nodes).forEach(function (refKey) {
      if (nodes[refKey][key]) {
        list.push(nodes[refKey][valueKey]);
      }
    });
    return list;
  };

  _proto.serializeListOnlyParent = function serializeListOnlyParent(key, nodes) {
    var _this12 = this;

    if (nodes === void 0) {
      nodes = this.nodes;
    }

    var valueKey = this.props.valueKey;
    var list = [];
    Object.keys(nodes).forEach(function (refKey) {
      var currentNode = nodes[refKey];

      if (currentNode.parentNode) {
        var parentNode = nodes[currentNode.parentNode.refKey];

        if (currentNode[key]) {
          if (!parentNode.checkAll) {
            list.push(nodes[refKey][valueKey]);
          } else if (!_this12.getTopParentNodeCheckState(nodes, currentNode) && parentNode.uncheckable) {
            list.push(nodes[refKey][valueKey]);
          }
        }
      } else {
        if (currentNode[key]) {
          list.push(nodes[refKey][valueKey]);
        }
      }
    });
    return list;
  };

  _proto.unserializeLists = function unserializeLists(lists, nextProps) {
    var _this13 = this;

    if (nextProps === void 0) {
      nextProps = this.props;
    }

    var _nextProps = nextProps,
        valueKey = _nextProps.valueKey,
        cascade = _nextProps.cascade,
        _nextProps$uncheckabl = _nextProps.uncheckableItemValues,
        uncheckableItemValues = _nextProps$uncheckabl === void 0 ? [] : _nextProps$uncheckabl; // Reset values to false

    Object.keys(this.nodes).forEach(function (refKey) {
      Object.keys(lists).forEach(function (listKey) {
        var node = _this13.nodes[refKey];

        if (cascade && 'parentNode' in node) {
          node[listKey] = node.parentNode[listKey];
        } else {
          node[listKey] = false;
        }

        lists[listKey].forEach(function (value) {
          if ((0, _utils.shallowEqual)(_this13.nodes[refKey][valueKey], value) && !uncheckableItemValues.some(function (uncheckableValue) {
            return (0, _utils.shallowEqual)(value, uncheckableValue);
          })) {
            _this13.nodes[refKey][listKey] = true;
          }
        });
      });
    });
  };

  _proto.toggleChecked = function toggleChecked(node, isChecked) {
    var nodes = (0, _utils2.clone)(this.nodes);
    this.toggleDownChecked(nodes, node, isChecked);
    node.parentNode && this.toggleUpChecked(nodes, node.parentNode, isChecked);
    var values = this.serializeListOnlyParent('check', nodes);
    return this.filterSelectedValues(values);
  };

  _proto.toggleUpChecked = function toggleUpChecked(nodes, node, checked) {
    var cascade = this.props.cascade;
    var currentNode = nodes[node.refKey];

    if (cascade) {
      if (!checked) {
        currentNode.check = checked;
        currentNode.checkAll = checked;
      } else {
        if (this.everyChildChecked(nodes, node)) {
          currentNode.check = true;
          currentNode.checkAll = true;
        } else {
          currentNode.check = false;
          currentNode.checkAll = false;
        }
      }

      if (node.parentNode) {
        this.toggleUpChecked(nodes, node.parentNode, checked);
      }
    }
  };

  _proto.toggleDownChecked = function toggleDownChecked(nodes, node, isChecked) {
    var _this14 = this;

    var _this$props8 = this.props,
        childrenKey = _this$props8.childrenKey,
        cascade = _this$props8.cascade;
    nodes[node.refKey].check = isChecked;

    if (!node[childrenKey] || !node[childrenKey].length || !cascade) {
      nodes[node.refKey].checkAll = false;
    } else {
      nodes[node.refKey].checkAll = isChecked;
      node.children.forEach(function (child) {
        _this14.toggleDownChecked(nodes, child, isChecked);
      });
    }
  };

  _proto.toggleNode = function toggleNode(key, node, toggleValue) {
    // 如果该节点处于 disabledChecbox，则忽略该值
    if (!node.uncheckable) {
      this.nodes[node.refKey][key] = toggleValue;
    }
  };

  _proto.toggleExpand = function toggleExpand(node, isExpand) {
    this.nodes[node.refKey].expand = isExpand;
  };

  _proto.renderDropdownMenu = function renderDropdownMenu() {
    var _this$props9 = this.props,
        locale = _this$props9.locale,
        searchable = _this$props9.searchable,
        placement = _this$props9.placement,
        searchKeyword = _this$props9.searchKeyword,
        renderExtraFooter = _this$props9.renderExtraFooter,
        renderMenu = _this$props9.renderMenu,
        menuStyle = _this$props9.menuStyle,
        menuClassName = _this$props9.menuClassName;
    var keyword = !(0, _isUndefined2.default)(searchKeyword) ? searchKeyword : this.state.searchKeyword;
    var classes = (0, _classnames.default)(menuClassName, this.addPrefix('checktree-menu'), this.addPrefix("placement-" + (0, _kebabCase2.default)(placement)));
    var menu = this.renderCheckTree();
    return React.createElement(_picker.MenuWrapper, {
      className: classes,
      style: menuStyle,
      ref: this.bindMenuRef,
      getPositionInstance: this.getPositionInstance
    }, searchable ? React.createElement(_picker.SearchBar, {
      placeholder: locale.searchPlaceholder,
      key: "searchBar",
      onChange: this.handleSearch,
      value: keyword
    }) : null, renderMenu ? renderMenu(menu) : menu, renderExtraFooter && renderExtraFooter());
  };

  _proto.renderNode = function renderNode(node, index, layer, classPrefix) {
    var _this15 = this;

    if (!node.visible) {
      return null;
    }

    var _this$state2 = this.state,
        activeNode = _this$state2.activeNode,
        expandAll = _this$state2.expandAll;
    var _this$props10 = this.props,
        valueKey = _this$props10.valueKey,
        labelKey = _this$props10.labelKey,
        childrenKey = _this$props10.childrenKey,
        renderTreeNode = _this$props10.renderTreeNode,
        renderTreeIcon = _this$props10.renderTreeIcon,
        cascade = _this$props10.cascade;
    var refKey = node.refKey;
    var key = (0, _isString2.default)(node[valueKey]) || (0, _isNumber2.default)(node[valueKey]) ? node[valueKey] : refKey;
    var children = node[childrenKey];
    var hasNotEmptyChildren = children && Array.isArray(children) && children.length > 0;
    var props = {
      value: node[valueKey],
      label: node[labelKey],
      index: index,
      layer: layer,
      active: activeNode ? (0, _utils.shallowEqual)(activeNode[valueKey], node[valueKey]) : false,
      visible: node.visible,
      disabled: this.getDisabledState(node),
      nodeData: node,
      children: children,
      expandAll: expandAll,
      checkState: this.getNodeCheckState(node, cascade),
      parentNode: node.parentNode,
      hasChildren: !!children,
      uncheckable: node.uncheckable,
      onSelect: this.handleSelect,
      onTreeToggle: this.handleToggle,
      onRenderTreeNode: renderTreeNode,
      onRenderTreeIcon: renderTreeIcon
    };

    if (props.hasChildren) {
      var _classNames, _classNames2;

      layer += 1; // 是否展开树节点且子节点不为空

      var openClass = classPrefix + "-open";
      var expandControlled = 'expandAll' in this.props;
      var expandALlState = expandControlled ? expandAll : expandAll || node.expand;
      var childrenClass = (0, _classnames.default)(classPrefix + "-node-children", (_classNames = {}, _classNames[openClass] = expandALlState && hasNotEmptyChildren, _classNames));
      var viewChildrenClass = (0, _classnames.default)(classPrefix + "-children", (_classNames2 = {}, _classNames2[this.addPrefix('all-uncheckable')] = this.getEveryChildUncheckable(node), _classNames2));
      var nodes = children || [];
      return React.createElement("div", {
        className: childrenClass,
        key: key,
        ref: this.bindNodeRefs.bind(this, refKey)
      }, React.createElement(_CheckTreeNode.default, (0, _extends2.default)({
        classPrefix: classPrefix,
        key: key,
        ref: this.bindNodeRefs.bind(this, refKey)
      }, props)), React.createElement("div", {
        className: viewChildrenClass
      }, nodes.map(function (child, i) {
        return _this15.renderNode(child, i, layer, classPrefix);
      })));
    }

    return React.createElement(_CheckTreeNode.default, (0, _extends2.default)({
      classPrefix: classPrefix,
      key: key,
      ref: this.bindNodeRefs.bind(this, refKey)
    }, props));
  };

  _proto.renderCheckTree = function renderCheckTree() {
    var _classNames3,
        _this16 = this,
        _classNames4;

    var _this$state3 = this.state,
        filterData = _this$state3.filterData,
        isSomeNodeHasChildren = _this$state3.isSomeNodeHasChildren;
    var _this$props11 = this.props,
        inline = _this$props11.inline,
        height = _this$props11.height,
        _this$props11$classNa = _this$props11.className,
        className = _this$props11$classNa === void 0 ? '' : _this$props11$classNa,
        onScroll = _this$props11.onScroll,
        locale = _this$props11.locale; // 树节点的层级

    var layer = 0;
    var treeViewClass = this.addPrefix('checktree-view');
    var classes = (0, _classnames.default)(treeViewClass, (_classNames3 = {}, _classNames3[className] = inline, _classNames3['without-children'] = !isSomeNodeHasChildren, _classNames3));
    var formattedNodes = this.getFormattedNodes(filterData);
    var nodes = formattedNodes.map(function (node, index) {
      return _this16.renderNode(node, index, layer, treeViewClass);
    });

    if (!nodes.some(function (v) {
      return v !== null;
    })) {
      return React.createElement("div", {
        className: this.addPrefix('none')
      }, locale.noResultsText);
    }

    var style = inline ? this.props.style : {};
    var styles = (0, _extends2.default)({
      height: height
    }, style);
    var treeNodesClass = (0, _classnames.default)(this.addPrefix('checktree-nodes'), (_classNames4 = {}, _classNames4[this.addPrefix('all-uncheckable')] = this.getEveryFisrtLevelNodeUncheckable(), _classNames4));
    return React.createElement("div", {
      ref: this.bindTreeViewRef,
      className: classes,
      style: styles,
      onScroll: onScroll,
      onKeyDown: this.handleKeyDown
    }, React.createElement("div", {
      className: treeNodesClass
    }, nodes));
  };

  _proto.render = function render() {
    var _this$props12 = this.props,
        open = _this$props12.open,
        block = _this$props12.block,
        cascade = _this$props12.cascade,
        style = _this$props12.style,
        locale = _this$props12.locale,
        inline = _this$props12.inline,
        disabled = _this$props12.disabled,
        valueKey = _this$props12.valueKey,
        labelKey = _this$props12.labelKey,
        cleanable = _this$props12.cleanable,
        className = _this$props12.className,
        countable = _this$props12.countable,
        placement = _this$props12.placement,
        appearance = _this$props12.appearance,
        classPrefix = _this$props12.classPrefix,
        defaultOpen = _this$props12.defaultOpen,
        placeholder = _this$props12.placeholder,
        container = _this$props12.container,
        containerPadding = _this$props12.containerPadding,
        toggleComponentClass = _this$props12.toggleComponentClass,
        onExit = _this$props12.onExit,
        onOpen = _this$props12.onOpen,
        onClose = _this$props12.onClose,
        onHide = _this$props12.onHide,
        onEnter = _this$props12.onEnter,
        onExited = _this$props12.onExited,
        onExiting = _this$props12.onExiting,
        onEntered = _this$props12.onEntered,
        onEntering = _this$props12.onEntering,
        renderValue = _this$props12.renderValue,
        rest = (0, _objectWithoutPropertiesLoose2.default)(_this$props12, ["open", "block", "cascade", "style", "locale", "inline", "disabled", "valueKey", "labelKey", "cleanable", "className", "countable", "placement", "appearance", "classPrefix", "defaultOpen", "placeholder", "container", "containerPadding", "toggleComponentClass", "onExit", "onOpen", "onClose", "onHide", "onEnter", "onExited", "onExiting", "onEntered", "onEntering", "renderValue"]);
    var _this$state4 = this.state,
        hasValue = _this$state4.hasValue,
        selectedValues = _this$state4.selectedValues;
    var classes = (0, _picker.getToggleWrapperClassName)('checktree', this.addPrefix, this.props, hasValue);
    var selectedItems = this.getSelectedItems(selectedValues);
    var selectedElement = placeholder;

    if (renderValue) {
      selectedElement = renderValue(selectedValues, selectedItems, selectedElement);
    } else if (hasValue && selectedValues.length) {
      selectedElement = React.createElement(_picker.SelectedElement, {
        selectedItems: selectedItems,
        countable: countable,
        valueKey: valueKey,
        labelKey: labelKey,
        prefix: this.addPrefix,
        cascade: cascade,
        locale: locale
      });
    }

    var unhandled = (0, _utils2.getUnhandledProps)(CheckTree, rest);
    return !inline ? React.createElement("div", {
      onKeyDown: this.handleToggleKeyDown,
      className: classes,
      style: style,
      tabIndex: -1,
      role: "menu",
      ref: this.bindContainerRef
    }, React.createElement(_OverlayTrigger.default, {
      ref: this.bindTriggerRef,
      positionRef: this.bindPositionRef,
      open: open,
      defaultOpen: defaultOpen,
      disabled: disabled,
      trigger: "click",
      placement: placement,
      onEnter: onEnter,
      onEntering: onEntering,
      onEntered: (0, _utils2.createChainedFunction)(this.handleOnOpen, onEntered),
      onExit: onExit,
      onExiting: onExiting,
      onExited: (0, _utils2.createChainedFunction)(this.handleOnClose, onExited),
      onHide: onHide,
      container: container,
      containerPadding: containerPadding,
      speaker: this.renderDropdownMenu()
    }, React.createElement(_picker.PickerToggle, (0, _extends2.default)({}, unhandled, {
      onClean: this.handleClean,
      componentClass: toggleComponentClass,
      cleanable: cleanable && !disabled,
      hasValue: hasValue,
      active: this.state.active
    }), selectedElement || locale.placeholder))) : this.renderCheckTree();
  };

  return CheckTree;
}(React.Component);

(0, _defineProperty2.default)(CheckTree, "defaultProps", {
  locale: {
    placeholder: 'Select',
    searchPlaceholder: 'Search',
    noResultsText: 'No results found',
    checkAll: 'All'
  },
  cascade: true,
  valueKey: 'value',
  labelKey: 'label',
  cleanable: true,
  countable: true,
  placement: 'bottomLeft',
  appearance: 'default',
  searchable: true,
  defaultValue: [],
  childrenKey: 'children',
  uncheckableItemValues: []
});
(0, _defineProperty2.default)(CheckTree, "handledProps", ["appearance", "block", "cascade", "childrenKey", "className", "classPrefix", "cleanable", "container", "containerPadding", "countable", "data", "defaultExpandAll", "defaultOpen", "defaultValue", "disabled", "disabledItemValues", "expandAll", "height", "inline", "labelKey", "locale", "menuClassName", "menuStyle", "onChange", "onClose", "onEnter", "onEntered", "onEntering", "onExit", "onExited", "onExiting", "onExpand", "onHide", "onOpen", "onScroll", "onSearch", "onSelect", "open", "placeholder", "placement", "renderExtraFooter", "renderMenu", "renderTreeIcon", "renderTreeNode", "renderValue", "searchKeyword", "searchable", "style", "toggleComponentClass", "uncheckableItemValues", "value", "valueKey"]);
(0, _reactLifecyclesCompat.polyfill)(CheckTree);
var enhance = (0, _utils2.defaultProps)({
  classPrefix: 'picker'
});

var _default = enhance(CheckTree);

exports.default = _default;