"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var React = _interopRequireWildcard(require("react"));

var _moment = _interopRequireDefault(require("moment"));

var _classnames = _interopRequireDefault(require("classnames"));

var _utils = require("../../utils");

var _MonthDropdown = _interopRequireDefault(require("../../Calendar/MonthDropdown"));

var _Header = _interopRequireDefault(require("../../Calendar/Header"));

var _View = _interopRequireDefault(require("./View"));

var Calendar =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2.default)(Calendar, _React$Component);

  function Calendar() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleMoveForword", function () {
      var onMoveForword = _this.props.onMoveForword;
      onMoveForword && onMoveForword(_this.getPageDate().clone().add(1, 'month'));
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "handleMoveBackward", function () {
      var onMoveBackward = _this.props.onMoveBackward;
      onMoveBackward && onMoveBackward(_this.getPageDate().clone().add(-1, 'month'));
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "disabledBackward", function () {
      var _this$props = _this.props,
          calendarDate = _this$props.calendarDate,
          index = _this$props.index;
      var isAfter = calendarDate[1].isAfter(calendarDate[0].clone().add(1, 'month'), 'month');

      if (index === 0) {
        return false;
      }

      if (!isAfter) {
        return true;
      }

      return false;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "disabledForword", function () {
      var _this$props2 = _this.props,
          calendarDate = _this$props2.calendarDate,
          index = _this$props2.index;
      var isAfter = calendarDate[1].isAfter(calendarDate[0].clone().add(1, 'month'), 'month');

      if (index === 1) {
        return false;
      }

      if (!isAfter) {
        return true;
      }

      return false;
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "disabledMonth", function (date) {
      var _this$props3 = _this.props,
          calendarDate = _this$props3.calendarDate,
          index = _this$props3.index;
      var isAfter = true;

      if (index === 1) {
        isAfter = date.isAfter(calendarDate[0], 'month');
        return !isAfter;
      }

      isAfter = calendarDate[1].isAfter(date, 'month');
      return !isAfter;
    });
    return _this;
  }

  var _proto = Calendar.prototype;

  _proto.getPageDate = function getPageDate() {
    var _this$props4 = this.props,
        calendarDate = _this$props4.calendarDate,
        index = _this$props4.index;
    return calendarDate[index];
  };

  _proto.shouldMountDate = function shouldMountDate(props) {
    var _ref = props || this.props,
        format = _ref.format;

    return /Y/.test(format) && /M/.test(format) && /D/.test(format);
  };

  _proto.render = function render() {
    var _classNames;

    var _this$props5 = this.props,
        calendarState = _this$props5.calendarState,
        onSelect = _this$props5.onSelect,
        onMouseMove = _this$props5.onMouseMove,
        onToggleMonthDropdown = _this$props5.onToggleMonthDropdown,
        onChangePageDate = _this$props5.onChangePageDate,
        format = _this$props5.format,
        disabledDate = _this$props5.disabledDate,
        className = _this$props5.className,
        value = _this$props5.value,
        hoverValue = _this$props5.hoverValue,
        isoWeek = _this$props5.isoWeek,
        limitStartYear = _this$props5.limitStartYear,
        limitEndYear = _this$props5.limitEndYear,
        classPrefix = _this$props5.classPrefix,
        rest = (0, _objectWithoutPropertiesLoose2.default)(_this$props5, ["calendarState", "onSelect", "onMouseMove", "onToggleMonthDropdown", "onChangePageDate", "format", "disabledDate", "className", "value", "hoverValue", "isoWeek", "limitStartYear", "limitEndYear", "classPrefix"]);
    var pageDate = this.getPageDate();
    var dropMonth = calendarState === 'DROP_MONTH';
    var addPrefix = (0, _utils.prefix)(classPrefix);
    var calendarClasses = (0, _classnames.default)(classPrefix, className, (_classNames = {}, _classNames[addPrefix('show-month-dropdown')] = dropMonth, _classNames));
    var unhandled = (0, _utils.getUnhandledProps)(Calendar, rest);
    return React.createElement("div", (0, _extends2.default)({}, unhandled, {
      className: calendarClasses
    }), React.createElement(_Header.default, {
      showMonth: true,
      date: pageDate,
      disabledBackward: this.disabledBackward(),
      disabledForword: this.disabledForword(),
      onMoveForword: this.handleMoveForword,
      onMoveBackward: this.handleMoveBackward,
      onToggleMonthDropdown: onToggleMonthDropdown
    }), React.createElement(_View.default, {
      activeDate: pageDate,
      value: value,
      hoverValue: hoverValue,
      onSelect: onSelect,
      onMouseMove: onMouseMove,
      disabledDate: disabledDate,
      isoWeek: isoWeek
    }), React.createElement(_MonthDropdown.default, {
      date: pageDate,
      show: dropMonth,
      disabledMonth: this.disabledMonth,
      onSelect: onChangePageDate,
      limitStartYear: limitStartYear,
      limitEndYear: limitEndYear
    }));
  };

  return Calendar;
}(React.Component);

(0, _defineProperty2.default)(Calendar, "defaultProps", {
  calendarDate: [(0, _moment.default)(), (0, _moment.default)().add(1, 'month')],
  index: 0
});
(0, _defineProperty2.default)(Calendar, "handledProps", ["calendarDate", "calendarState", "className", "classPrefix", "disabledDate", "format", "hoverValue", "index", "isoWeek", "limitEndYear", "limitStartYear", "onChangePageDate", "onMouseMove", "onMoveBackward", "onMoveForword", "onSelect", "onToggleMonthDropdown", "value"]);
var enhance = (0, _utils.defaultProps)({
  classPrefix: 'calendar'
});

var _default = enhance(Calendar);

exports.default = _default;